Require Import translation.
Require Import ASTD.
Require Import String.

Lemma get_nameWorks :
  forall (a : astd)
         (name : string),
    isAstdNamedN a name ->
    (get_name a) = name.
Proof.
  intros a name IsNamed.
  destruct a;inversion IsNamed;subst;simpl;reflexivity.
Qed.

Lemma get_nameWorks2 :
  forall (a : astd),
    isAstdNamedN a (get_name a).
Proof.
  intros a.
  destruct a;simpl.
  apply (IsAstdNamedN_elem).
  apply (IsAstdNamedN_automata).
Qed.

Lemma getAstdFromStateListWorks :
  forall (states : listOfAstdStates)
         (a : astd)
         (name : string),
    getAstdFromStateList name states = Some a ->
    isAstdNamedNFromAstdList a name states.
Proof.
  induction states.
  -
    intros a name GetFromList.
    simpl in GetFromList.
    discriminate.
  -
    intros a0 name GetFromList.
    inversion GetFromList.
    destruct (string_dec (get_name a) name).
    +
      inversion H0;subst.
      apply (IsAstdNamedNFromAstdList_isElem).
      destruct a0;simpl;[apply IsAstdNamedN_elem|apply IsAstdNamedN_automata].
    +
      apply (IsAstdNamedNFromAstdList_isNotElem).
      apply (IHstates a0 name H0).
Qed.

Theorem isAstdNamedInList_implies_isAstdNamed :
  forall (a : astd)
         (name : string)
         (states : listOfAstdStates),
    isAstdNamedNFromAstdList a name states ->
    isAstdNamedN a name.
Proof.
  induction states.
  -
    intros IsAstdNamed.
    inversion IsAstdNamed.
  -
    intros IsAstdNamed.
    inversion IsAstdNamed;subst.
    +
      assumption.
    +
      apply (IHstates H2).
Qed.            

Theorem astdNameUnique :
  forall (a : astd)
         (name1 name2 : string),
    isAstdNamedN a name1 ->
    isAstdNamedN a name2 ->
    name1 = name2.
Proof.
  intros a name1 name2 IsAstdNamed1 IsAstdNamed2.
  inversion IsAstdNamed1;subst;inversion IsAstdNamed2;subst;reflexivity.
Qed.    