Require Import B_state.
Require Import String.
Require Import stateEquivalence.
Require Import B_semantics.
Require Import B_langage.


Lemma noVariableNamedNPreservedByReplaced :
  forall (vLi vLi' : bStateList)
         (name nameReplaced : string)
         (v : bState),
    noVariableIsNamedNInBState name v ->
    listOfBStateIsListOfBStateWhereStateNamedNIsReplacedByState vLi' vLi nameReplaced v ->
    noVariableIsNamedNInBStateList name vLi ->
    noVariableIsNamedNInBStateList name vLi'.
Proof.
  induction vLi.
  -
    intros vLi' name nameReplaced v NoVarNamed ListReplaced NoVarNamed2.
    inversion ListReplaced.
    apply (NoVariableIsNamedNInBStateList_nil).
  -
    intros vLi' name nameReplaced v NoVarNamed ListReplaced NoVarNamed2.
    inversion NoVarNamed2;subst.
    inversion ListReplaced;subst.
    +
      apply (NoVariableIsNamedNInBStateList_notNil);assumption.
    +
      apply (NoVariableIsNamedNInBStateList_notNil).
      apply (IHvLi bStateReplaced name nameReplaced v NoVarNamed H6  H2).
      assumption.
Qed.

(* Lemma variableNamesUniquePreservedByReplaced : *)
(*   forall (vLi vLi' : bStateList) *)
(*          (name : string) *)
(*          (v : bState), *)
(*     listOfBStateIsListOfBStateWhereStateNamedNIsReplacedByState vLi' vLi name v -> *)
(*     variableNamesAreUniqueInBState v -> *)
(*     variableNamesAreUniqueInBStateList vLi -> *)
(*     variableNamesAreUniqueInBStateList vLi'. *)
(* Proof. *)
(*   induction vLi. *)
(*   - *)
(*     intros vLi' name v ListReplaced NamesUnique NameUniqueInList. *)
(*     inversion ListReplaced;subst. *)
(*     apply (VariableNamesAreUniqueInBStateList_nil). *)
(*   - *)
(*     intros vLi' name v ListReplaced NamesUnique NamesUniqueInList. *)
(*     inversion NamesUniqueInList;subst. *)
(*     inversion ListReplaced;subst. *)
(*     + *)
(*       apply (VariableNamesAreUniqueInBStateList_notNil). *)
(*       * *)
(*         assumption. *)
(*       * *)
        
    
Lemma isAStateOfListWhereReplaced :
  forall (var val : string)
         (vLi vLi' vLiSubState : bStateList),
    listOfBStateIsListOfBStateWhereStateNamedNIsReplacedByState vLi' vLi var (Automata_B_state var val vLiSubState) ->
    isAStateOfBStateList (Automata_B_state var val vLiSubState) vLi'.
Proof.
  induction vLi.
  -
    intros vLi' vLiSub ListReplaced.
    inversion ListReplaced.
  -
    intros vLi' vLiSub ListReplaced.
    inversion ListReplaced;subst.
    +
      apply (IsAStateOfBStateList_isElem).
    +
      apply (IsAStateOfBStateList_isNotElem).
      apply (IHvLi).
      assumption.
Qed.

Lemma nameOfReplacedState :
  forall (name var val : string)
         (vLi vLi' vLiSubState : bStateList),
    listOfBStateIsListOfBStateWhereStateNamedNIsReplacedByState vLi' vLi name (Automata_B_state var val vLiSubState) ->
    var = name.
Proof.
  induction vLi.
  -
    intros vLi' vLiSub ListReplaced.
    inversion ListReplaced.
  -
    intros vLi' vLiSub ListReplaced.
    inversion ListReplaced;subst.
    +
      reflexivity.
    +
      apply (IHvLi bStateReplaced vLiSub H4).
Qed.

Lemma isAStateOfListWhereReplacedNotNamed :
  forall (var1 var2 val1 val2 : string)
         (vLi vLi' vLiSubState1 vLiSubState2 : bStateList),
    var1 <> var2 ->
    isAStateOfBStateList (Automata_B_state var2 val2 vLiSubState2) vLi ->
    listOfBStateIsListOfBStateWhereStateNamedNIsReplacedByState vLi' vLi var1 (Automata_B_state var1  val1 vLiSubState1) ->
    isAStateOfBStateList (Automata_B_state var2 val2 vLiSubState2) vLi'.
Proof.
  induction vLi.
  -
    intros vLi' vLiSubState1 vLiSubState2 Diff IsAState ListReplaced.
    inversion ListReplaced;subst.
  -
    intros vLi' vLiSubState1 vLiSubState2 Diff IsAState ListReplaced.
    inversion ListReplaced;subst.
    +
      inversion IsAState;subst.
      *
        absurd (var1 = var1);[assumption|reflexivity].
      *
        apply IsAStateOfBStateList_isNotElem.
        assumption.
    +
      inversion IsAState;subst.
      *
        apply (IsAStateOfBStateList_isElem).
      *
        apply (IsAStateOfBStateList_isNotElem).
        apply (IHvLi bStateReplaced vLiSubState1 vLiSubState2 Diff H1 H4).
Qed.
    
Lemma variableNamesAreUniqueInABSubState :
  forall (v : bState)
         (vLi : bStateList),
    variableNamesAreUniqueInBStateList vLi ->
    isAStateOfBStateList v vLi ->
    variableNamesAreUniqueInBState v.
Proof.
  induction vLi.
  -
    intros VarUnique IsAState.
    inversion IsAState.
  -
    intros VarUnique IsAState.
    inversion VarUnique;subst.
    inversion IsAState;subst.
    +
      assumption.
    +
      apply (IHvLi H1 H5).
Qed.

Lemma variableNamesAreUniqueInStateWhereReplaced :
  forall (v : bState)
         (name : string)
         (vLi vLi' : bStateList),
    listOfBStateIsListOfBStateWhereStateNamedNIsReplacedByState vLi vLi' name v ->
    variableNamesAreUniqueInBStateList vLi ->
    variableNamesAreUniqueInBState v.
Proof.
  induction vLi.
  -
    intros vLi'.
    intros Replaced.
    inversion Replaced.
    intros.
    apply VariableNamesAreUniqueInBState_elem.
  -
    intros vLi' Replaced NamesUnique.
    inversion NamesUnique;subst.
    inversion Replaced;subst.
    +
      assumption.
    +
      apply (IHvLi bState H8 H1).
Qed.

Lemma absurd_isValOfVar_noVariableNamed :
  forall (v : bState)
         (var val : string)
         (P : Prop),
    isValOfVarInState val var v ->
    noVariableIsNamedNInBState var v ->
    P.
Proof.
  apply (bState_mut (fun (v : bState) =>
                       forall (var val : string)
                              (P : Prop),
                         isValOfVarInState val var v ->
                         noVariableIsNamedNInBState var v ->
                         P)
                     (fun (vLi : bStateList) =>
                        forall (var val : string)
                               (P : Prop),
                          isValOfVarInListOfBStates val var vLi ->
                          noVariableIsNamedNInBStateList var vLi ->
                          P)).
  -
    intros var val P IsVal.
    inversion IsVal.
  -
    intros s s0 vLi IHvLi var val P IsValOfVar NoVarNamed.
    inversion NoVarNamed;subst.
    inversion IsValOfVar;subst.
    +
      destruct H4.
      reflexivity.
    +
      apply (IHvLi var val P H3 H2).
  -
    intros var val P IsValOfVar.
    inversion IsValOfVar.
  -
    intros v IHv vLi IHvLi var val P IsValOfVar NoVarNamed.
    inversion NoVarNamed;subst.
    inversion IsValOfVar;subst.
    +
      apply (IHv var val P H4 H3).
    +
      apply (IHvLi var val P H4 H2).
Qed.

Lemma absurd_isValOfVarInList_noVariableNamedInList :
  forall (vLi : bStateList)
         (var val : string)
         (P : Prop),
    isValOfVarInListOfBStates val var vLi ->
    noVariableIsNamedNInBStateList var vLi ->
    P.
Proof.
  induction vLi.
  -
    intros var val P IsValOfVar.
    inversion IsValOfVar.
  -
    intros var val P IsValOfVar NoVarNamed.
    inversion NoVarNamed;subst.
    inversion IsValOfVar;subst.
    +
      apply (absurd_isValOfVar_noVariableNamed b var val);assumption.
    +
      apply (IHvLi var val P);assumption.
Qed.

Lemma variableNamesAreUniqueInBStateList_otherDef :
  forall (v : bState)
         (vLi : bStateList),
    variableNamesAreUniqueInBState v ->
    variableNamesAreUniqueInBStateList vLi ->
    (forall (name : string),
       (noVariableIsNamedNInBStateList name vLi \/ noVariableIsNamedNInBState name v)) ->
    variableNamesAreUniqueInBStateList (ConsBStateList v vLi).
Proof.
  intros v vLi NamesUniqueInState NamesUniqueInList NoVarNamed.
  apply (VariableNamesAreUniqueInBStateList_notNil);[assumption| | | assumption].
  +
    intros var val IsValOfVar.
    destruct (NoVarNamed var);[assumption|apply (absurd_isValOfVar_noVariableNamed v var val);assumption].
  +
    intros val var IsValOfVar.
    destruct (NoVarNamed var);[apply (absurd_isValOfVarInList_noVariableNamedInList vLi var val);assumption|assumption].
Qed.


Lemma isStateChangedInUniqueState :
  forall (v v' : bState)
         (var val : string),
    isValOfVarInState val var v ->
    isStateWhereVarChangedForVal v' v var val ->
    variableNamesAreUniqueInBState v ->
    v' = v.
Proof.
  apply (bState_mut (fun (v : bState) =>
                       forall (v' : bState)
                              (var val : string),
                         isValOfVarInState val var v ->
                         isStateWhereVarChangedForVal v' v var val ->
                         variableNamesAreUniqueInBState v ->
                         v' = v)
                    (fun (vLi : bStateList) =>
                       forall (vLi' : bStateList)
                              (var val : string),
                         isValOfVarInListOfBStates val var vLi ->
                         isStateListWhereVarChangedForVal vLi' vLi var val ->
                         variableNamesAreUniqueInBStateList vLi ->
                         vLi' = vLi)).
  -
    intros v' var val IsValOfVar.
    inversion IsValOfVar.
  -
    intros s s0 vLi IHvLi v' var val IsValOfVar IsStateChanged NamesUnique.
    inversion NamesUnique;subst.
    inversion IsValOfVar;subst;inversion IsStateChanged;subst.
    +
      reflexivity.
    +
      apply (absurd_isStateListWhereValChanged_noVariableNamed vLi subStatesChanged s s0);assumption.
    +
      apply (absurd_isValOfVarInList_noVariableNamedInList vLi var val);assumption.
    +
      rewrite (IHvLi subStatesChanged var val H4 H8 H3). reflexivity.
  -
    intros vLi' var val IsVal. inversion IsVal.
  -
    intros v IHv vLi IHvLi vLi' var val IsVal IsStateChanged NamesUnique.
    inversion NamesUnique;subst.
    inversion IsStateChanged;inversion IsVal;subst.
    +
      rewrite (IHv stChanged var val H12 H8 H4). reflexivity.
    +
      apply (H3 val var) in H12. apply (absurd_isStateWhereValChanged_noVariableNamed v stChanged var val);assumption.
    +
      apply (H2 var val) in H12. apply (absurd_isStateListWhereValChanged_noVariableNamed vLi subStatesQueueChanged var val);assumption.     
    +
      rewrite (IHvLi subStatesQueueChanged var val H12 H8 H1). reflexivity.
Qed.

Theorem affectationInUniqueState :
  forall (var val1 val2 : string)
         (li : bStateList)
         (v : bState),
    substitution_step (Automata_B_state var val1 li) (Affectation var val2) v ->
    variableNamesAreUniqueInBState (Automata_B_state var val1 li) ->
    v = (Automata_B_state var val2 li).
Proof.
  intros var val1 val2 li v Step NameUnique.
  inversion Step;subst.
  inversion H3;subst.
  reflexivity.
  inversion NameUnique.
  apply (absurd_isStateListWhereValChanged_noVariableNamed li subStatesChanged var val2);assumption.
Qed.  

Lemma affectationInUniqueState2 :
  forall (var val : string)
         (v v' : bState),
    isValOfVarInState val var v ->
    substitution_step v (Affectation var val) v' ->
    variableNamesAreUniqueInBState v ->
    v' = v.
Proof.
  intros var val v v' IsValOfVar Step.
  inversion Step;subst.
  apply (isStateChangedInUniqueState v v' var val);assumption.
Qed.

Lemma isValOfVarInState_uniqueInBState :
  forall (v : bState)
         (var val1 val2 : string),
    isValOfVarInState val1 var v ->
    isValOfVarInState val2 var v ->
    variableNamesAreUniqueInBState v ->
    val1 = val2.
Proof.
  apply (bState_mut (fun (v : bState) =>
                       forall (var val1 val2 : string),
                         isValOfVarInState val1 var v ->
                         isValOfVarInState val2 var v ->
                         variableNamesAreUniqueInBState v ->
                         val1 = val2)
                    (fun (vLi : bStateList) =>
                       forall (var val1 val2 : string),
                         isValOfVarInListOfBStates val1 var vLi ->
                         isValOfVarInListOfBStates val2 var vLi ->
                         variableNamesAreUniqueInBStateList vLi ->
                         val1 = val2)).
  -
    intros var val1 val2 IsValOfVar1.
    inversion IsValOfVar1.
  -
    intros s s0 vLi IHvLi var val1 val2 IsValOfVar1 IsValOfVar2 NamesUnique.
    inversion NamesUnique;subst.
    inversion IsValOfVar1;inversion IsValOfVar2;subst.
    +
      reflexivity.
    +
      apply (absurd_isValOfVarInList_noVariableNamedInList vLi s val2);assumption.
    +
      apply (absurd_isValOfVarInList_noVariableNamedInList vLi s val1);assumption.
    +
     apply (IHvLi var val1 val2);assumption.
  -
    intros var val1 val2 IsValOfVar. inversion IsValOfVar.
  -
    intros v IHv vLi IHvLi var val1 val2 IsValOfVar1 IsValOfVar2 NamesUnique.
    inversion NamesUnique;subst. inversion IsValOfVar1;inversion IsValOfVar2;subst.
    +
      apply (IHv var val1 val2);assumption.
    +
      apply (H2 var val1) in H6.
      apply (absurd_isValOfVarInList_noVariableNamedInList vLi var val2);assumption.
    +
      apply (H2 var val2) in H11.
      apply (absurd_isValOfVarInList_noVariableNamedInList vLi var val1);assumption.
    +
      apply (IHvLi var val1 val2);assumption.
Qed.


Ltac rewrite_values :=
  match goal with
    |[ H0 : variableNamesAreUniqueInBState (Automata_B_state ?name ?nameOfState ?vLi),
            H1 : isValOfVarInState ?val ?name (Automata_B_state ?name ?nameOfState ?vLi) |- _]
     =>
     assert (val = nameOfState);[rewrite (isValOfVarInState_uniqueInBState (Automata_B_state name nameOfState vLi) name val nameOfState);[reflexivity|assumption|apply IsValOfVarInState_isElem|assumption]|subst]
    |[ H: listOfBStateIsListOfBStateWhereStateNamedNIsReplacedByState ?vLi1 ?vLi2 ?name Elem_B_state |- _]
     =>
     assert (vLi1 = vLi2);[apply (replacingByElemBState vLi1 vLi2 name);assumption|subst]
  end.
