Require Import translation.
Require Import B_state.
Require Import B_semantics.
Require Import B_langage.
Require Import ASTD.
Require Import states.
Require Import ASTDstep.
Require Import String.
Require Import stateEquivalence.
Require Import addTransitionWorks.
Require Import Theorems.
Require Import makePrePostWorks.
Require Import wellConstructed.
Require Import theoremsOnUniqueAstdList.
Open Scope list_scope.

Theorem astd_step_inAstdWithMoreTrans :
  forall (name init : string)
         (label : transition_label)
         (states : listOfAstdStates)
         (sF dF : list string)
         (s s' : state)
         (t : transition)
         (transitions : list transition),
    astd_step s (Automata name states transitions sF dF init) label s' ->
    astd_step s  (Automata name states (t::transitions) sF dF init) label s'.
Proof.
  intros name init label states sF dF s s' t trans Step.
  inversion Step;subst.
  -
    apply (Automata_rule1 n1 n2 init name gu label h' h s0 initOfN2 a2 a1 states (t::trans) sF dF final).
    simpl.
    right.
    assumption.
    assumption.
    assumption.
    assumption.
    assumption.
    assumption.
    assumption.
  -
    apply (Automata_rule2) with (initOfN2 := initOfN2) (gu := gu) (a2b := a2b) (a1:= a1) (statesOfN2 := statesOfN2) (transitionsOfN2 := transitionsOfN2) (shallowFinalOfN2 := shallowFinalOfN2) (deepFinalOfN2 := deepFinalOfN2) (final := final).
    simpl.
    right.
    assumption.
    assumption.
    assumption.
    assumption.
    assumption.
    assumption.
    assumption.
    assumption.
    assumption.
  -
    apply (Automata_rule3) with (initOfN2 := initOfN2) (s2b := s2b) (statesOfN2 := statesOfN2) (transitionsOfN2 := transitionsOfN2) (shallowFinalOfN2 := shallowFinalOfN2) (deepFinalOfN2 := deepFinalOfN2) (gu := gu) (final := final) (a2b := a2b) (a1 := a1).
    simpl.
    right.
    assumption.
    assumption.
    assumption.
    assumption.
    assumption.
    assumption.
    assumption.
    assumption.
    assumption.
    assumption.
    assumption.
  -
    apply (Automata_rule4) with (gu := gu) (final := final) (a1 := a1).
    simpl.
    right.
    assumption.
    assumption.
    assumption.
    assumption.
    assumption.
    assumption.
  -
    apply (Automata_rule5) with (initOfN1 := initOfN1) (n1b := n1b) (statesOfN1 := statesOfN1) (a2 := a2) (a1 := a1)(transitionsOfN1 := transitionsOfN1) (deepFinalOfN1 := deepFinalOfN1) (shallowFinalOfN1 := shallowFinalOfN1) (gu := gu) (final := final).
    simpl.
    right.
    assumption.
    assumption.
    assumption.
    assumption.
    assumption.
    assumption.
    assumption.
    assumption.
    assumption.
  -
    apply (Automata_rule6) with a;assumption.
Qed.


Theorem translateAllTransitionsWorks :
  forall (trans : list transition)
         (states : listOfAstdStates)
         (sFinal dFinal : list string)
         (nameOfA init nameOfOp : string)
         (v v' : bState)         
         (l : list operation)
         (s : state)
         (args : list (string * string)),
    translateAllTransitions trans nil nameOfA states = Some l ->
    b_step v l (Label nameOfOp args) v' ->
    astdNameAreUniqueInAstd (Automata nameOfA states trans sFinal dFinal init) ->
    isAstdListWellDefined states ->
    bStateAndAstdStateAreEquivalentInAstdNamed v s nameOfA ->
    variableNamesAreUniqueInBState v ->
    isAStateOfTheAstd s (Automata nameOfA states trans sFinal dFinal init) ->
    exists (s' : state),
      bStateAndAstdStateAreEquivalentInAstdNamed v' s' nameOfA /\
      astd_step s (Automata nameOfA states trans sFinal dFinal init)
                (Transition_label nameOfOp args) s'.
Proof.
  induction trans.
  -
    intros states sF dF name init nameOfOp v v' opes s  args.
    intros Translate Step.
    simpl in Translate.
    inversion Translate;subst.
    inversion Step.
    inversion H1.
  -
    intros states sF dF name init nameOfOp v v' opes s args.
    intros Translate Step AstdNamesUnique WellDef StateEquiv BNamesUnique IsAState.
    simpl in Translate.
    case_eq (translateAllTransitions trans nil name states);intros;rewrite H in Translate;[|discriminate].
    destruct (addTransitionWorks a l opes v v' args name nameOfOp states Translate).
    apply ( translateAllTransitionsMakeWellConstructedOperations name trans states l H).
    assumption.
    destruct H0.
    destruct H0.
    destruct H1.
    destruct H2.
    +
      destruct H2.
      destruct H3.
      apply (makePrePostWorks v v' s name init nameOfOp args states sF dF x a trans x0 H0 H1 AstdNamesUnique WellDef H2 H3 BNamesUnique StateEquiv IsAState H4).
    +
      apply (nameUniqueWithLessTrans) in AstdNamesUnique.
      destruct (IHtrans states sF dF name init nameOfOp v v' l s args H H2 AstdNamesUnique WellDef StateEquiv BNamesUnique).
      apply (isAStateWithLessTrans) with a;assumption.
      exists x1.
      destruct H3.
      split;[assumption|].
      apply astd_step_inAstdWithMoreTrans.
      assumption.
Qed.
