Require Import translation.
Require Import B_langage.
Require Import ASTD.
Require Import String.
Require Import B_state.
Require Import List.
Require Import B_state.
Require Import states.
Require Import ASTDstep.
Require Import stateEquivalence.
Require Import B_semantics.
Require Import mergeWorks.
Require Import translateAllTransitionsWorks.
Require Import modifyPrePostWorks.
Require Import Theorems.
Require Import translateStateListWorks.
Require Import theoremsOnNames.
Require Import wellConstructed.

Theorem translationCorrection :
  forall (a : astd)
         (v v' : bState)
         (s : state)
         (opes : list operation)
         (nameOfA nameOfOp : string)
         (args : list (string*string)),
    translateAstd a = Some opes ->
    isAstdNamedN a nameOfA ->
    b_step v opes (Label nameOfOp args) v' ->
    isAStateOfTheAstd s a ->
    bStateAndAstdStateAreEquivalentInAstdNamed v s nameOfA ->
    variableNamesAreUniqueInBState v ->
    isWellDefined a ->
    exists (s' : state),
      bStateAndAstdStateAreEquivalentInAstdNamed v' s' nameOfA /\
      astd_step s a (Transition_label nameOfOp args) s'.
Proof.
  apply (astd_mut (fun (a : astd) =>
                     forall (v v' : bState)
                            (s : state)
                            (opes : list operation)
                            (nameOfA nameOfOp : string)
                            (args : list (string*string)),
                       translateAstd a = Some opes ->
                       isAstdNamedN a nameOfA ->
                       b_step v opes (Label nameOfOp args) v' ->
                       isAStateOfTheAstd s a ->
                       bStateAndAstdStateAreEquivalentInAstdNamed v s nameOfA ->
                       variableNamesAreUniqueInBState v ->
                       isWellDefined a ->
                       exists (s' : state),
                         bStateAndAstdStateAreEquivalentInAstdNamed v' s' nameOfA /\
                         astd_step s a (Transition_label nameOfOp args) s')
                  (fun (states : listOfAstdStates) =>
                     forall (vSub' : bState)
                            (subState : state)
                            (h : histState)
                            (vLi vLi' : bStateList)
                            (a : astd)
                            (args : list (string * string))
                            (opes : list operation)
                            (name nameOfOp nameOfState : string),
                       translateStateList states name = Some opes ->
                       b_step (Automata_B_state name nameOfState vLi) opes (Label nameOfOp args) (Automata_B_state name nameOfState vLi') ->
                       listOfBStateIsListOfBStateWhereStateNamedNIsReplacedByState vLi' vLi nameOfState vSub' ->
                       isAStateOfTheAstd  subState a ->
                       bStateAndAstdStateAreEquivalentInAstdNamed (Automata_B_state name nameOfState vLi) (Automata_state nameOfState h subState) name ->
                       variableNamesAreUniqueInBState (Automata_B_state name nameOfState vLi) ->
                       isAstdListWellDefined states ->
                       astdNameAreUniqueInAstdList states ->
                       isAstdNamedNFromAstdList a nameOfState states ->
                       exists (subState' : state),
                         bStateAndAstdStateAreEquivalentInAstdNamed vSub' subState' nameOfState /\
                         astd_step subState a (Transition_label nameOfOp args) subState')).
  -
    intros s0 v v' s opes name nameOfOp args.
    intros translate isAstdNamed step.
    simpl in translate.
    inversion translate.
    subst.
    inversion step.
    inversion H1.
  -
    intros name states IHstates trans sFinal dFinal init v v' s opes nameOfA nameOfOp args.
    intros translate isNamed step isAState stateEquiv nameUnique wellDef.
    inversion isNamed;subst.
    simpl in translate.
    case_eq (translateStateList states nameOfA);intros;rewrite H in translate;[|discriminate].
    case_eq (translateAllTransitions trans nil nameOfA states);intros;rewrite H0 in translate;[|discriminate].
    destruct (mergeIsOneOrTheOther l0 l opes (Label nameOfOp args) v v' translate).
    apply (translateAllTransitionsMakeWellConstructedOperations nameOfA trans states l0 H0).
    apply (translateStateListIsWellConstructed states nameOfA l H).
    assumption.
    +
      inversion wellDef;subst.
      inversion H13;subst.
      destruct (translateAllTransitionsWorks trans states sFinal dFinal nameOfA init nameOfOp v v' l0 s args H0 H1 H13 H9 stateEquiv nameUnique isAState).
      destruct H2.
      exists x.
      split;assumption.
    +
      inversion isAState;subst.
      inversion stateEquiv;subst.
      inversion wellDef;subst.
      inversion H19;subst.
      destruct (translateStateListMakesProperState states nameOfA nameOfState l listBSubStateRes v' (Label nameOfOp args) H nameUnique H22 H1).
      destruct H2.
      destruct H2.
      subst.
      destruct (IHstates x0 subState h listBSubStateRes x subAstd args l nameOfA nameOfOp nameOfState H H1 H2 H10 stateEquiv nameUnique H15 H22 H6).
      destruct H3.
      exists (Automata_state nameOfState h x1).
      split.
      apply (BStateAndAstdStateAreEquivalentInAstdNamed_subStateElem) with (bSubState := x0) (listBSubState := listBSubState).
      *
        assumption.
      *
        assumption.
      *
        apply (listWhereReplacedTwice listBSubState listBSubStateRes x x0 bSubState).
        inversion nameUnique;subst.
        assumption.
        unfold not. intros. subst. inversion H3;subst. inversion H5.
        unfold not. intros. subst. inversion H9;subst. inversion H5.
        assumption.
        assumption.
      *
        apply (Automata_rule6) with subAstd.
        assumption.
        assumption.
  -
    intros vSub' subState h vLi vLi' a args opes name nameOfOp nameOfState translate step.
    simpl in translate.
    inversion translate;subst.
    inversion step.
    inversion H1.
  -
    intros a IHa states IHstates vSub' subState h vLi vLi' subAstd args opes name nameOfOp nameOfState.
    intros Translate Step ListReplaced isAState StateEquiv BNameUnique WellDef AstdNamesUnique IsAstdNamedFromList.
    inversion IsAstdNamedFromList;subst.
    +
      simpl in Translate.
      case_eq (translateAstd a);intros;rewrite H in Translate;[|discriminate].
      case_eq (translateStateList states name);intros;rewrite H0 in Translate;[|discriminate].
      inversion StateEquiv;subst.
      destruct (IHa bSubState vSub' subState l nameOfState nameOfOp args H H2).
      apply (modifyPrePostWorks2 l name nameOfState vLi vLi' listBSubState bSubState vSub' a subState (ConsAstdStates a states)).
      rewrite (get_nameWorks a nameOfState) in Translate.
      apply (translateStateListWithMerge a name nameOfState states vLi' vLi (Label nameOfOp args) l0 (modifyPrePost l name nameOfState) opes H0 Translate).
      apply modifyPrePostMakesWellConstructed.
      assumption.
      assumption.
      assumption.
      assumption.
      assumption.
      assumption.
      assumption.
      apply (IsAstdNamedNFromAstdList_isElem).
      assumption.
      assumption.
      assumption.
      assumption.
      assumption.
      assumption.
      apply (variableNamesUnique_preservedByInclusion nameOfState bSubState vLi listBSubState).
      inversion BNameUnique.
      assumption.
      assumption.
      inversion WellDef.
      assumption.
      destruct H1.
      exists x.
      split;assumption.
    +
      simpl in Translate.
      case_eq (translateAstd a);intros;rewrite H in Translate;[|discriminate].
      case_eq (translateStateList states name);intros;rewrite H0 in Translate;[|discriminate].
      destruct (IHstates vSub' subState h vLi vLi' subAstd args l0 name nameOfOp nameOfState H0).
      *
        apply (mergeWithTranslateStateList a subAstd states vLi vLi' name nameOfState (Label nameOfOp args) l0 opes l Translate).
        apply (translationIsWellConstructed a l H).
        apply (translateStateListIsWellConstructed states name l0 H0).
        assumption.
        assumption.
        assumption.
        assumption.
      *
        assumption.
      *
        assumption.
      *
        assumption.
      *
        assumption.
      *
        inversion WellDef.
        assumption.
      *
        inversion AstdNamesUnique.
        assumption.
      *
        assumption.
      *
        exists x.
        assumption.
Qed.
